
// please permission first.
// if you used this.
// twitter : @Miracle100KS

//===Main function
   // definition function
   #define saturate(x) clamp(x,0.,1.)
   #define amax(x) max(0.,x)
   #define reso(x) smoothstep(0.,1.,x)
   #define mid(x) max(x,0.)
   #define time TIME*.2

   // high precision
   #define min16float highp float
   #define min16vec4 highp vec4
   #define min16vec3 highp vec3
   #define min16vec2 highp vec2

   // auto function
   min16float autoPos( min16float pos )
   { return reso(length(pos)); }
   min16float autoPos( min16vec2 pos )
   { return reso(length(pos)); }
   min16float autoPos( min16vec3 pos )
   { return reso(length(pos)); }
   min16float autoDistance( min16float pos )
   { return saturate(length(pos)); }
   min16float autoDistance( min16vec2 pos )
   { return saturate(length(pos)); }
   min16float autoDistance( min16vec3 pos )
   { return saturate(length(pos)); }
   min16float autoTime( min16float tm, float a, float b )
   { return amax(sin(tm*a) + cos(tm*b)); }

    // constant
    const int ON = 1;
    const int OFF = 0;
    const float iPos = .366025404;
    const float fPos = .211324865;
    const float rPos = 43758.5453123;
    const vec3 W = vec3(.2125, .7154, .0721);

//===Structure
  struct detection{
     float day;
     float night;
     float dusk;
     float rain;
     float cave;
     float sunset;
     float sunrise;
  }at;

  struct Output{
    min16vec4 texSampler;
    min16vec4 texTarget;
  }Input;  

//===Rotation matrix
    mat2 rotate(in float theta){
      float c = cos(theta);
      float s = sin(theta);
    return mat2(c,s,-s,c); }

//===Noise
    min16vec2 rand(min16vec2 p){
        p = vec2(dot(p, vec2(127.1, 311.7)), dot(p,vec2(269.5, 183.3))); 
        return -1.0+2.0*fract(sin(p)*rPos);
             //                 //               //
  } min16float noise(min16vec2 p){
       vec2 i = floor( p+( p.x+p.y )*iPos);
       vec2 a = p-i+( i.x+i.y )*fPos;
       vec2 o = ( a.x > a.y )? vec2(1.,.0) : vec2(0.,1.);
       vec2 b = a-o+fPos;
    	 vec2 c = a-1.+2.*fPos;

       vec3 h = max(.5-vec3(dot(a,a),dot(b,b),dot(c,c)),.0);
       vec3 x = pow(h, vec3(5.));
       vec3 n = x*vec3(dot(a, rand(i+0.)), dot(b,rand(i+o)), dot(c, rand(i+1.0)));
    return dot(n, vec3(70.));
  } //> 2D noise

   min16float rand( min16float p )
   { return -1.0+2.0*fract(sin(p)*rPos); }
    min16float noise( min16float p ){
     	 float o = 1.;
       float i = p+iPos;
       float a = p-i+fPos;
       float b = a-o+fPos;
   	 float c = a-1.+2.*fPos;

       vec3 h = max(.5-vec3(a*a,b*b,c*c),.0);
       vec3 x = pow(h,vec3(4.));
       vec3 n = x*vec3(a*rand(i+0.),(b*rand(i+o)),(c*rand(i+1.0)));
    return dot(n,vec3(70.));
   } //> basic noise

//===Mapping
min16vec3 tonemap( vec3 x, float strength ){
      float W = 2.;
      float A = .03;
      float N = .4;
      float Z = .7;
      float E = .05;
      float S = .65;
      vec3 result = ((x*(W*x+N*A)+Z*E)/(x*(W*x+A)+Z*S))-E/S;
     result *= strength; return result;
   } //tonemap function

   min16vec3 saturation(vec3 rgb, float adjust)
      { vec3 intensity = vec3(dot(rgb, W)); //}
       return mix(intensity, rgb, adjust); 
// } saturation function

  } void _tonemapSet(inout vec3 set, detection at){
    set.rgb = mix(set.rgb,tonemap(set.rgb,1.),at.day);
    set.rgb = mix(set.rgb,tonemap(set.rgb,.75),at.dusk);
  } void _saturationSet(inout vec3 set, detection at){
vec3 clrGrayscale[2] = vec3[2](saturation(set.rgb,.65),saturation(set.rgb,.4));

   // monochrome
   set.rgb = mix(set.rgb,clrGrayscale[1],at.rain);
   // contrast
   set.rgb *= mix(vec3(1.),clrGrayscale[0],at.rain);

  } void _coloringSet(inout vec3 clr,detection at){
     vec3 clrW = mix(vec3(1),vec3(1.15,1.2,1.25), at.day);
       clrW = mix(clrW, vec3(.8), at.cave);
       clrW = mix(clrW, vec3(.41,.46,.855), at.night);
       clrW = mix(clrW, vec3(1.,.5,-1.5), at.dusk);
       clrW = mix(clrW, vec3(1.8), at.rain);
   clr.rgb *= clrW;
  } // default mapping

