// please permission first.
// if you used this.
// twitter : @Miracle100KS

//===Main function
   // definition function
   #define saturate(x) clamp(x,0.,1.)
   #define amax(x) max(0.,x)
   #define reso(x) smoothstep(0.,1.,x)
   #define mid(x) max(x,0.)
   #define time TIME*.2

   // auto function
   float autoPos( float pos )
   { return reso(length(pos)); }
   float autoPos( float2 pos )
   { return reso(length(pos)); }
   float autoPos( float3 pos )
   { return reso(length(pos)); }
   float autoDistance( float pos )
   { return saturate(length(pos)); }
   float autoDistance( float2 pos )
   { return saturate(length(pos)); }
   float autoDistance( float3 pos )
   { return saturate(length(pos)); }
   float autoTime( float tm, float a, float b )
   { return amax(sin(tm*a) + cos(tm*b)); }

   // constant
   static const int ON = 1;
   static const int OFF = 0;
   static const float iPos = .366025404;
   static const float fPos = .211324865;
   static const float3 W = float3(.2125, .7154, .0721);

//===Structure
  struct detection{
    float day;
    float night;
    float dusk;
    float rain;
    float cave;
    float sunset;
    float sunrise;
  }at;
  
  struct Output{
   float4 texSampler;
   float4 texTarget;
  }Input;

//===Rotation matrix
  float2x2 rotate(in float theta){
   float c = cos(theta);
   float s = sin(theta);
  return float2x2(c,-s,s,c); }

//===Noise
  float2 rand(float2 p){
   p = float2(dot(p, float2(127.1, 311.7)), dot(p, float2(269.5, 183.3))); 
   return -1.0+2.0*frac(sin(p)*43758.5453123);

  } float noise(float2 p){
      float2 i = floor(p+(p.x+p.y)*iPos);
      float2 a = p-i+(i.x+i.y)*fPos;
      float2 o = (a.x > a.y)? float2(1.,.0) : float2(0.,1.);
      float2 b = a-o+fPos;
      float2 c = a-1.+2.*fPos;
      float3 h = max(.5-float3(dot(a,a),dot(b,b),dot(c,c)),.0);
      float3 x = pow(h, float3(5.,5.,5.));
      float3 n = x*float3(dot(a, rand(i+0.)), dot(b,rand(i+o)), dot(c, rand(i+1.0)));
     return dot(n, float3(70.,70.,70.));
  } //> 2D noise

  float rand(float p)
  { return -1.0+2.0*frac(sin(p)*43758.5453123); }
   float noise(float p){
     float o = 1.;
     float i = p+iPos;
     float a = p-i+fPos;
     float b = a-o+fPos;
     float c = a-1.+2.*fPos;
     float3 h = max(.5-float3(a*a,b*b,c*c),.0);
     float3 x = pow(h, float3(4.,4.,4.));;
     float3 n = x*float3(a*rand(i+0.),(b*rand(i+o)),(c*rand(i+1.0)));
    return dot(n,float3(70.,70.,70.));
  } //> basic noise

//====Mapping
  float3 tonemap(float3 x,float strength){
   float W = 2.1;
   float A = .03;
   float N = .4;
   float Z = .7;
   float E = .05;
   float S = .65;
   float3 result = ((x*(W*x+N*A)+Z*E)/(x*(W*x+A)+Z*S))-E/S;
   result *= strength; 
   return result;
 } //tonemap function

  float3 saturation(float3 rgb, float adjust)
   { float3 intensity = dot(rgb,W); //} 
     return lerp(intensity, rgb, adjust);
 //} saturation function

  } void _tonemapSet(inout float3 set, detection at){
    set.rgb = lerp(set.rgb,tonemap(set.rgb,1.),at.day);
    set.rgb = lerp(set.rgb,tonemap(set.rgb,.75),at.dusk);
  } void _saturationSet(inout float3 set, detection at){
    float3 Grayscale[2] = {saturation(set.rgb,.4),saturation(set.rgb,.65)};

    // monochrome
    set.rgb = lerp(set.rgb,Grayscale[0],at.rain);
    // contrast
    set.rgb *= lerp(float3(1.,1.,1.),Grayscale[1],at.rain);

  } void _coloringSet(inout float3 clr,detection at){float3 clrW;
    clrW = lerp(float3(1.,1.,1.), float3(1.15,1.2,1.25), at.day);
    clrW = lerp(clrW, float3(.8,.8,.8), at.cave);
    clrW = lerp(clrW, float3(.41,.46,.855), at.night);
    clrW = lerp(clrW, float3(1.,.5,-1.5), at.dusk);
    clrW = lerp(clrW, float3(1.8,1.8,1.8), at.rain);
   clr.rgb *= clrW;
  } //default mapping 