#include "ShaderConstants.fxh"
#include "lib/option.fxh"

struct PS_Input
{
    float4 position : SV_Position;
    float4 color : COLOR;
    float3 poss : POSS;
};

struct PS_Output
{
    float4 color : SV_Target;
};

float3 skycolor(float lp, float2 fcc, float4 fc,detection at){
float3 coloring[4] = {float3(.0,.2,1.3),float3(.0,.45,.9),float3(.0,.12,.27),float3(1.4,1.4,1.4)};
float3 cday = coloring[0];
float3 cdusk = coloring[1];
float3 cnight = coloring[2];
float3 crain = coloring[3]*fc.rgb;

// sky color
    float3 color;
    if(!(fcc.x == 0.)){
    color = lerp(float3(0.,.0,0.),cday,at.day);
    color = lerp(color,cdusk,at.dusk);
    color = lerp(color,cnight,at.night);
    color = lerp(color,crain,at.rain);

// gradient color 1
    } float3 grad1 = fc.rgb;
    if(!(fcc.x == 0.)){
    grad1 = lerp(float3(0.,0.,0.),float3(1.8,2.4,2.8)*fc.rgb,at.day);
    grad1 = lerp(grad1,float3(.2,.45,1.5),at.dusk);
    grad1 = lerp(grad1,float3(.3,.2,.4),at.night);
    grad1 = lerp(grad1,float3(1.5,1.5,1.5)*fc.rgb,at.rain);

// gradient color 2
    } float3 grad2 = fc.rgb;
    if(!(fcc.x == 0.)){
    grad2 = lerp(float3(0.,0.,0.), float3(1.,1.,1.),at.day); 
    grad2 = lerp(grad2,float3(2.,2.,2.),at.dusk);
    grad2 = lerp(grad2,float3(.35,.35,.35),at.night);
    if(at.night <.8){grad2 = lerp(grad2,float3(2.,2.,2.),at.rain);}

// gradient color 3
    } float3 grad3 = fc.rgb;
    if(!(fcc.x == 0.)){
    grad3 = lerp(fc.rgb,fc.rgb,at.day);
    grad3 = lerp(grad3,fc.rgb,at.dusk);
    grad3 = lerp(grad3,fc.rgb,at.night);
    grad3 = lerp(grad3,fc.rgb,at.rain);

// gradient distance
    } float3 sky;
    sky = lerp(color,grad1,reso(pow(lp*3.8,2.)));
    sky = lerp(sky,grad2,reso(pow(lp*3.,1.5)));
    sky = lerp(sky,grad3,reso(lp*1.4));
    return sky;
}

ROOT_SIGNATURE
void main(in PS_Input PSInput, out PS_Output PSOutput){
float4 fc = FOG_COLOR;
float2 fcc = FOG_CONTROL;
float4 cc = CURRENT_COLOR;
float lp = length(PSInput.poss.xz);

detection at;
at.day = saturate(fc.r + fc.g);
at.night = 1.-at.day;
at.rain = 1.-smoothstep(.3,.66,fcc.x);
at.dusk = saturate(.5-abs(.5-saturate(cc.b)));

float3 skies = skycolor(lp,fcc,fc,at);
float3 result = lerp(skies,fc.rgb,cc.rgb);

    PSOutput.color = float4(result,1.);
}