#include "ShaderConstants.fxh"
#include "util.fxh"
#include "lib/Hash.fxh"

struct PS_Input
{
	float4 position : SV_Position;
	float2 uv : TEXCOORD_0_FB_MSAA;
	float3 cpos : CPOS;
};

struct PS_Output
{
	float4 color : SV_Target;
};

/////////////////////////////////////////////////////////////////
///////////////////////// STOP! /////////////////////////////////
// Made by @bicubic7
// Don't steal anything!
// Don't use code without permit!
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

float drawcloud(float2 pos,float value){
	float tot = 0.,s= 1.;
	float2 ptime = TIME*float2(-2.,1.3);
		pos += ptime*0.008;

for(float f = 0.; f < 4.; f++){
	tot += Noise(pos)*1.*value/s; s *= 2.2;
	pos *= 2.8;
	pos += ptime*0.15*sin(f);
}
return 1.-pow(.1,max(1.-tot,0.));
}

float4 renderclouds(float2 pos,float3 rpos,float py){
	float ys = clamp(py, 0.0, 0.4) * 2.5 + 0.7;
	float3 tot = float3(0,0,0);
	float value = lerp(1.95,1.2,1.-pow(FOG_CONTROL.y,10.0));
	float a = .0;

	float3 basecloudcolor = FOG_COLOR.rgb*1.3;
	float dither = dithering(rpos*400.0)*0.05;
		pos *= 1.2;

for(float f = 0.; f <= 10.; f++){

		float denc = drawcloud(pos+dither, value);
		value /= 1.07; pos /= 1.03;

	if(denc > 0.0){
			float night = pow(max(min(1.-FOG_COLOR.r*1.5,1.),.0),1.2);  
			float3 cloudcolorc = lerp(float3(1.,.8,1.),float3(.2,.4,.8)*0.8,night);
			cloudcolorc = lerp(cloudcolorc,float3(1.,.8,1.),(1.-FOG_COLOR.b)*clamp((FOG_COLOR.r-.15)*1.25,0.,1.));
			cloudcolorc = lerp(cloudcolorc, FOG_COLOR.rgb*1.5, 1.-pow(FOG_CONTROL.y,10.0));
			tot = lerp(tot,lerp(cloudcolorc*1.5,basecloudcolor*denc,denc),denc);
			a += lerp(0.,(1.-denc*0.4)*(1.-a),denc);
	}
	basecloudcolor /= 1.03;
}
	float4 result = float4(tot,a);
	result.a = lerp(result.a, 0.0, min(pow(ys, 10.0), 1.0));
	result = float4(result.rgb, clamp((result.a-0.6)*1.5, 0.0, 1.0)) * result.a;
return result;
}

ROOT_SIGNATURE
void main(in PS_Input PSInput, out PS_Output PSOutput)
{

	float3 po = PSInput.cpos/(PSInput.cpos.y-0.14);
	float3 fp = float3(po.x, 0., po.z);

	float4 cloud = renderclouds(fp.xz*1.5,po,PSInput.cpos.y);
PSOutput.color = float4(cloud.rgb,cloud.a);

}
